import java.util.Iterator;
import java.util.NoSuchElementException;

// this is just a bonus to give you a few additional ideas
// find out how it works on your own ;-)

// PS: this is using full java and is meant as incentive to learn more than just the bits you get told about in the course
// places of interest are marked with /**/
public final class FibIterable implements Iterable<Integer> {
	// how many numbers to calculate
	private int count;
	
	/**/
	private class FibIterator implements Iterator<Integer> {
		private int last = -1;
		private int current = 1;
		private int index = 0;
		
		@Override
		public boolean hasNext() {
			/**/
			return index < count; 
		}

		@Override
		public Integer next() {
			if( index++ >= count ) {
				throw new NoSuchElementException( "index " + index + " > " + count );
			}
			
			current += last;
			last = current - last;
			
			return current;
		}

		@Override
		public void remove() {
			throw new UnsupportedOperationException();
		}
	}
	
	@Override
	public Iterator<Integer> iterator() {
		return new FibIterator();
	}
	
	public FibIterable(int count) {
		this.count = count;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		FibIterable iterable = new FibIterable(10);
		
		for( int i : iterable ) {
			System.out.println( i );
		}
	}

}
