public interface InterfaceA {
	// interfaces may only contain public and abstract methods
	public abstract void methodA();
	
	// you can leave out the keywords public and abstract
	// you usually do this, but it doesn't change anything
	void methodB();
	// methodB is public and abstract nonetheless
	
	// private and protected are not allowed to be used
	// uncomment the definition to get the following error:
	// Illegal modifier for the interface method InterfaceA.privateMethod(); only public & abstract are permitted
	//private void privateMethod();
	//protected void protectedMethod();

	// neither is final allowed for methods
	// again:
	// Illegal modifier for the interface method InterfaceA.privateMethod(); only public & abstract are permitted
	//final void finalMethod();
	
	
	// nor is static allowed
	// Illegal modifier for the interface method InterfaceA.privateMethod(); only public & abstract are permitted
	//static void main() {}
	
	// you're only allowed to declare public static final fields:
	public static final int testInt = -1;
	// you can leave out public final and static again 
	static final double testDouble = 3.1415;
	final double anotherDouble = 2.72;
	int anotherInt = 0;
	// testDouble, anotherDouble and anotherInt are final, public and static
	
	// one usually leaves the keywords public, final, static out, because they are redundant
	
	// interfaces are a way to store constants (as you have seen above)
	// but we can even store objects, too
	String testString = "Hello World";
	int[] testIntArray = new int[] { 1, 2, 3 };
}
